'' This object provides an assortment of debugging and dump routines that
'' directly write to the display screen (to avoid interaction with windows).

OBJ
  vga : "OS_vgaHiresText"

PUB hex(x, y, value, digits)
'' Print a hexadecimal number
  value <<= (8 - digits) << 2
  repeat digits
    vga.setScreenChar(x++,y,lookupz((value <-= 4) & $F : "0".."9", "A".."F"))
  return x

PUB bin(x, y, value, digits)
'' Print a binary number
  value <<= 32 - digits
  repeat digits
    vga.setScreenChar(x++,y,(value <-= 1) & 1 + "0")
  return x

PUB str(x, y, stringptr)
'' Print a zero-terminated string
  repeat strsize(stringptr)
    vga.setScreenChar(x++,y,byte[stringptr++])
  return x

PUB dec(x,y,value) | i
'' Print a decimal number
  if value < 0
    -value
    vga.setScreenChar(x++,y,"-")
  i := 1_000_000_000
  repeat 10
    if value => i
      vga.setScreenChar(x++,y,value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      vga.setScreenChar(x++,y,"0")
    i /= 10
  return x

PUB decFixed(x, y, value, width) | i, p, f, a, b, c
'' Print a decimal number of fixed width
  p := @a
  f~
  if value < 0
    -value
    byte[p++] := "-"
  i := 1_000_000_000
  repeat 10
    if value => i
      byte[p++] := value / i + "0"
      value //= i
      f~~
    elseif f or i == 1
      byte[p++] := "0"
    i /= 10
  byte[p]~
  i := strsize(@a)
  if i < width
    repeat width - i
      vga.setScreenChar(x++,y," ")
  return str(x,y,@a)

PUB chr(x, y, value, width)
'' Print up to 4 characters LSB first
  repeat width <# 4
    vga.setScreenChar(x++,y,value)
    value >>= 8 